#!/usr/bin/perl 

$prefix_1 = "VK";
$prefix_2 = "ZL";

$| = 1;
#print $#ARGV."\n";

if ($#ARGV >= 0){
	require "$ARGV[0]";
}else{
	$prefix_1 = "VK";
	$prefix_2 = "ZL";
	$telnet_2 = "./myTelnet.pl 10152 hamgate.rpi.net.au";
	$telnet_1 = "./myTelnet.pl 10152 radio-active.net.au";

}


use Net::Telnet ();
use IPC::Open2;

use IO::Socket;


use FileHandle;
use Fcntl;

$remote = new FileHandle;


$RX_READ = new FileHandle;
$RX_WRITE = new FileHandle;

$WR_READ = new FileHandle;
$WR_WRITE = new FileHandle;

fcntl ($RX_READ, 4, 04000);
fcntl ($WR_READ, 4, 04000);

print "myFilter.pl 0.00\n";

#      $RX_READ     = IO::Socket::INET->new(PeerAddr => 'first.aprs.net',
##                                        PeerPort => '1314',
#													 Timeout  => '10',
#                                        Proto    => 'tcp');
#		$RX_READ->autoflush(1);
#		$RX_WRITE = $WR_READ;

#IPC::Open2::open2($RX_READ, $RX_WRITE, "telnet first.aprs.net 1314");
IPC::Open2::open2($RX_READ, $RX_WRITE, $telnet_1);
fcntl ($RX_READ, 4, 04000);

                sleep (3);


#      $WR_READ     = IO::Socket::INET->new(PeerAddr => 'radio-active.net.au',
#                                        PeerPort => '10152',
#													 Timeout  => '10',
#                                        Proto    => 'tcp');
#		$WR_READ->autoflush(1);
#		$WR_WRITE = $WR_READ;

#IPC::Open2::open2($WR_READ, $WR_WRITE, "telnet radio-active.net.au 10152");
IPC::Open2::open2($WR_READ, $WR_WRITE, $telnet_2);
fcntl ($WR_READ, 4, 04000);
                sleep (3);


	print $RX_WRITE "user VK2TDS pass 21422 VERS myFilter.pl 0.01\n\r\n";
	print $WR_WRITE "user VK2TDS pass 21422 VERS myFilter.pl 0.01\n\r\n";


#        $t = new Net::Telnet (port => 1314, errmode => "return" );
#        $t->open("uranium");
#        @lines = $t->cmd("/usr/bin/who");
#        print @lines;


	while (1 ==1){
			$line = <$RX_READ>;
			$line =~ s/\n//;
			$line =~ s/\r//;
			if (length ( $line) > 0) {
				CHECK ($line);
			}
			$line = <$WR_READ>;
			$line =~ s/\n//;
			$line =~ s/\r//;

			if (length ( $line) > 0) {
				CHECK_Upload($line);
			}
			select(undef, undef, undef, 0.25);

}



sub CHECK_Upload {

	local ($line) = shift;
   if (index ($line, "# aprsd") > -1 ){
      print "UPLOAD AUTHENTICATE\n";
      print $WR_WRITE "user VK2TDS pass 21422 VERS myFilter.pl 0.01\n\r\n";
   }


	if (index ($line, "::") >= 0) {
		$call_to = substr ($line, index($line, "::")+2, 9);
		if (index ($call_to, " ") > 0) {
			$call_to = substr ($call_to, 0, index($call_to, " "));
		}
		$call_to = substr($call_to,0,9);
	} else {
		$call_to = "";
	}

	

	$call = substr($line,0,  index ($line, "\>"));
	if (index($call, "-") > 0 ) {
		$call = substr($line,0,  index ($line, "-"));
	}
	if (substr ($call,0,1)  eq "}"){
		$call = substr ($call, 1,10);
	} 
	$call = substr ($call,0,9);	

#	print $call."\n";


	$OK = 0;
	$OK = 1;


#open up incoming if the packet comes from that station outgoing
#************** TO DO
#	if (($CallArray{$call} == 1) & (defined ($call_to))){
#		if ($CallArray{$call} > 0){
#			$CallArray{$call} = time;
#			$OK = 1;
#		}	
#	}



	if (index ($call_to, "USERLIST") == 0 || 
		index ($call_to, "javaMSG") == 0 ||
		index ($call_to, "FBB") == 0 ||
		index ($line, "\>FBB:") >= 0 ||   # was >FBB *********
		index ($call, "\#") == 0){
		$OK = 0;
	}

	if (index ($line, "\>MAIL:") > 0 ){
		$message = substr ($line, index($line,"\>MAIL:")+6,200);
#		print "MESSAGE $message\n";
		if (index ($message, "BBS") == 0 || index ($message,"******") >= 0){
			$OK = 0;
		};	
	}

	$path = substr ($line, 0, index ($line,":"));

	$_ = $path;
	if (/\*[^\*]+\*/ > 0){
		# we have TCPIP*,VK2TDS* which is illegal
		if( index ($line, ",VK4GO\*:") >= 0){
			print "*";
			$line =~ s/,VK4GO\*:/:/;
			$OK = 1;
		} else {
			$OK = 0;
			print "BAD";
		}
	}


#		# we have TCPIP*,VK2TDS* which is illegal
#		if( index ($line, "\*:") >= 0){
#			$star = 1;
#			$line =~ s/\*:/:/;
#		}


# Delete comments to do

	if ($OK == 1){ 
		print $RX_WRITE "$line\n";
		print "UPLOAD : $call : $call_to :".substr($line,0,50)."\n";
	} else {

		print "UPKILL : $call : $call_to : ".substr($line,0,50)."\n";

	}


}



#COMES FROM #1, REMOTE
sub CHECK {

	local ($line) = shift;
   if (index ($line, "# aprsd") > -1 ){
      print "DOWNLOAD AUTHENTICATE\n";
      print $RX_WRITE "user VK2TDS pass 21422 VERS myFilter.pl 0.01\n\r\n";
   }

	if (index ($line, "::") >= 0) {
		$call_to = substr ($line, index($line, "::")+2, 9);
		if (index ($call_to, " ") > 0) {
			$call_to = substr ($call_to, 0, index($call_to, " "));
		}
		$call_to = substr($call_to,0,9);
	} else {
		$call_to = "";
	}

	

	$call = substr($line,0,  index ($line, "\>"));
	if (index($call, "-") > 0 ) {
		$call = substr($line,0,  index ($line, "-"));
	}
	if (substr ($call,0,1)  eq "}"){
		$call = substr ($call, 1,10);
	} 
	
	$call = substr ($call,0,9);

	$star = 0;
	$_ = substr ($line, 0, index ($line,":"));

	if (/\*[^\*]+\*/ > 0){
		# we have TCPIP*,VK2TDS* which is illegal
		if( index ($line, "\*:") >= 0){
			$star = 1;
			$line =~ s/\*:/:/;
		}
	}




#	print $call."\n";

	$OK = 1;

	if (index ($line, "\>MAIL:") > 0 ){
		$message = substr ($line, index($line,"\>MAIL:")+6,200);
		print "MESSAGE $message\n";
		if (index ($message, "BBS") == 0){
			$OK = 0;
		};	
	}


	if (index ($call_to, "USERLIST") == 0 || index ($call_to, "javaMSG") == 0){
		$OK = 0;
	}

	if ($OK == 1){ 
		if ($star == 1){ print "*";}
		print "DOWNLOAD : $call : $call_to : ".substr($line,0,50)."\n";
		print $WR_WRITE "$line\n";
		
	} else {
		if (index ($line, "\#") == 0){
			print "DOWNKILL : ".substr($line,0,60)."\n";
			
		} else {
			print "DOWNKILL : ".substr($line,0,60)."\n";		
		}

	}

}