#!/usr/bin/perl 
use Net::Telnet ();
use IPC::Open2;
use IO::Socket;
use FileHandle;
use Fcntl;

$version = "myFilter.pl 0.03";

$| = 1;
require ("perlPOS.pl");

if ($#ARGV >= 0){
	require "$ARGV[0]";
}else{
	print "Please add the name of the configuration file on the command line\n";
	die;
}


	$RX_READ = new FileHandle;		$RX_WRITE = new FileHandle;
	$WR_READ = new FileHandle;		$WR_WRITE = new FileHandle;

	IPC::Open2::open2($RX_READ, $RX_WRITE, $telnet_1);
	IPC::Open2::open2($WR_READ, $WR_WRITE, $telnet_2);

	fcntl ($RX_READ, 4, 04000);	fcntl ($WR_READ, 4, 04000);

initialise (@grid_OK);

print "$version\n";

	while (1 ==1){
			$pause = 1;
			$line = <$RX_READ>; $line =~ s/\n//; $line =~ s/\r//;
			if (length ( $line) > 0) {
				CHECK ($line);
				$pause = 0;
			}
			$line = <$WR_READ>; $line =~ s/\n//; $line =~ s/\r//;

			if (length ( $line) > 0) {
				CHECK_Upload($line);
				$pause = 0;
			}
			if ($pause == 1){			
				select(undef, undef, undef, 0.25);
			}
}



sub CHECK_Upload {

	local ($line) = shift;
	if (index ($line, "# aprsd") > -1 ){
      print "UPLOAD AUTHENTICATE\n";
		print $WR_WRITE $auth_2;
	}

	#this is the myTelnet lines
	if ((index ($line, "Trying ") == 0 ) | 
		 (index ($line, "Connected") == 0) | 
		 (index ($line, "Escape") == 0)){
		$line = "";
		$OK = 0;
	}


	if (index ($line, "::") >= 0) {
		$call_to = substr ($line, index($line, "::")+2, 9);
		if (index ($call_to, " ") > 0) {
			$call_to = substr ($call_to, 0, index($call_to, " "));
		}
		$call_to = substr($call_to,0,9);
	} else {
		$call_to = "";
	}
	

	$call = substr($line,0,  index ($line, "\>"));
	if (index($call, "-") > 0 ) {
		$call = substr($line,0,  index ($line, "-"));
	}
	if (substr ($call,0,1)  eq "}"){
		$call = substr ($call, 1,10);
	} 
	$call = substr ($call,0,9);	



	$OK = 0;
	$OK = 1;


#open up incoming if the packet comes from that station outgoing
#************** TO DO
#	if (($CallArray{$call} == 1) & (defined ($call_to))){
#		if ($CallArray{$call} > 0){
#			$CallArray{$call} = time;
#			$OK = 1;
#		}	
#	}


#Junk packets... No use to anyone.
	if (index ($call_to, "USERLIST") == 0 || 
		index ($call_to, "javaMSG") == 0 ||
		index ($call_to, "FBB") == 0 ||
		index ($line, "\>FBB:") >= 0 ||   # was >FBB *********
		index ($call, "\#") == 0){
		$OK = 0;
	}

	if (index ($line, "\>MAIL:") > 0 ){
		$message = substr ($line, index($line,"\>MAIL:")+6,200);
		if (index ($message, "BBS") == 0 || index ($message,"******") >= 0){
			$OK = 0;
		};	
	}

	$path = substr ($line, 0, index ($line,":"));

	$_ = $path;
	if (/\*[^\*]+\*/ > 0){
		# we have TCPIP*,VK2TDS* which is illegal
		if( index ($line, ",VK4GO\*:") >= 0){
			print "*";
			$line =~ s/,VK4GO\*:/:/;
			$OK = 1;
		} else {
			$OK = 0;
			print "BAD";
		}
	}


#Packet is too short
	if (length($line) < 10){
		$OK = 0;
	}

#		# we have TCPIP*,VK2TDS* which is illegal
#		if( index ($line, "\*:") >= 0){
#			$star = 1;
#			$line =~ s/\*:/:/;
#		}


# Delete comments to do


	if ($OK == 1){ 
		print $RX_WRITE "$line\n";
		print "UPLOAD : $call : $call_to :".substr($line,0,50)."\n";
	} else {

		print "UPKILL : $call : $call_to : ".substr($line,0,50)."\n";

	}


}




sub CHECK {

	local ($line) = shift;
	
	$debug = "";
	
	# If we receive the signon message, then we have a new connection. Then 
	# we need to send the AUTHENTIFICATION message

	if (index ($line, "# aprsd") > -1 ){
		print "DOWNLOAD AUTHENTICATE\n";
		print $WR_WRITE $auth_1;
	}

	# There are several messages from myTelnet.pl that should be deleted.
	# so we delete them :-)

	if ((index ($line, "Trying ") == 0 ) | 
		 (index ($line, "Connected") == 0) | 
		 (index ($line, "telnet") == 0) | 
		 (index ($line, "Escape") == 0)){
		$line = "";
		$OK = 0;
	}


	# If there is a TO call in the message, extract this. Else blank. Remove
	# any spaces from the callsign. 
	
	if (index ($line, "::") >= 0) {
		$call_to = substr ($line, index($line, "::")+2, 9);
		if (index ($call_to, " ") > 0) {
			$call_to = substr ($call_to, 0, index($call_to, " "));
		}
		$call_to = substr($call_to,0,9);
		if (index($call_to, "-") >0){
			$call_to = substr($call_to,0,  index ($call_to, "-"));
		}
#		print "call$call_to\n";

	} else {
		$call_to = "";
	}

	
	# Work out the FROM callsign, removing the SSID
	# if the first charcter is a { remove it... 

	$call = substr($line,0,  index ($line, "\>"));
	if (index($call, "-") > 0 ) {
		$call = substr($line,0,  index ($line, "-"));
	}
	if (substr ($call,0,1)  eq "}"){
		$call = substr ($call, 1,10);
	} 
	$call = substr ($call,0,9);


	# Sometimes wer get TCPIP*,VK2TDS* which is illegal
	$star = 0;
	$_ = substr ($line, 0, index ($line,":"));
	if (/\*[^\*]+\*/ > 0){
		# we have TCPIP*,VK2TDS* which is illegal
		if( index ($line, "\*:") >= 0){
			$star = 1;
			$line =~ s/\*:/:/;
			}
	}

	$OK = 0;
#	print $CallArray{$call};

	# Have we previously been defined as a LOCAL by CALLSIGN? The Callsign
	# array is then set to = 1

	if ($CallArray{$call} == 1) {
		$OK = 1;
		$debug = $debug . " [ PREVIOUSLY VERIFIED ]";
	} else {

		# Search for the callsign prefix. If we find it, Define it as being
		# local

		foreach $prefix (@prefix){
			if ( index ($call, $prefix) == 0){
				$CallArray{$call} = 1;
				$OK = 1;
				$debug = $debug . " [ CALLSIGN VERIFIED ]";
			}
		}
	}

	#??????
	#OK if the too call has been validated by position
	# NOTE: If we use >1 for CallArray(Call_To) we will get a cascade of
	# opening up. Station A opens B opens C
	if (defined ($call_to) & ($CallArray{$call_to} == 1)){
		if ((! defined ($CallArray{$call})) | ($CallArray{$call} > 1 )){
			$CallArray{$call} = time;
		}
		$OK = 1;
		$debug = $debug . " [ TO CALLSIGN ALREADY VERIFIED ]";
	}


	# If the TO callsign is within the range let it through.
	foreach $prefix (@prefix){
		if ( index ($call, $prefix) == 0){
			if ((! defined ($CallArray{$call})) | ($CallArray{$call} > 1 )){
				$CallArray{$call} = time;
			}
			$OK = 1;
			$debug = $debug . " [ TO CALLSIGN VERIFIED ]";
		}
	}


	# If we are not letting the packet through by callsign, then see if we
	# should let it through by POSITION

	if ($OK == 0){
#		$show = 1;
		$mygrid = validate_line ($line);	

		if (length($mygrid) > 1){
			$CallArray{$call} = 1;
			$OK = 1;
			$debug = $debug . " [ POSITION OK ]";
		}
	}

	#why?	
	#reset the timer.
	if ((defined ($call_to))){
		if (($CallArray{$call} > 1)){
			$CallArray{$call} = time;
			$OK = 1;
		}	
	}

	#BUG**** TIMEOUT
	if (defined ($CallArray{$call})){
		$diff = time - $CallArray{$call};
		if (($OK == 0) &  ($diff < 3200)){
			$OK = 1;
			$debug = $debug . " [ TIMEOUT BUG ]";
		}		
	}

	if (index ($line, "\>MAIL:") > 0 ){
		$message = substr ($line, index($line,"\>MAIL:")+6,200);
		print "MESSAGE KILLED $message\n";
#		if (index ($message, "BBS") == 0){
			$OK = 0;
#		};	
	}


	if (index ($call_to, "USERLIST") == 0 || index ($call_to, "javaMSG") == 0){
		$OK = 0;
	}

	if ($OK == 1){ 
		print $debug."\n";
		if ($star == 1){ print "*";}
		print "DOWNLOAD : $call : $call_to : ".substr($line,0,50)."\n";
		print $WR_WRITE "$line\n";
		
	} else {
		if (index ($line, "\#") == 0){

			print "DOWNKILL : ".substr($line,0,60)."\n";
			
		} else {
#			print "DOWNKILL : ".substr($line,0,60)."\n";		
		}

	}

}